## fake data generation

# set parameters

kappa1=1e-10
kappa2=1e-10


xi0= c(1:g)
xi0=xi0/xi0[1]

pi0= xi0^2/(sum(xi0^2))

psitilde0 = rep(.5,n)
PSI0 = diag(psitilde0^2) + kappa2*diag(n)
BB0=matrix(rnorm_ALB(n*M),n,M)
# eliminate some elements
for (i in 1:(M-1))
{
  for (j in (i+1):M)
  {
 BB0[i,j]   =0
  }
}
for (i in 1:M) {BB0[i,i]=1}


BBvec0=c()
for (j in 1:M)
{
  BBvec0=c(BBvec0,BB0[(j+1):n,j])
}
  

mu0=matrix(0,M,g)
VVtilde0=array(0,dim=c(M,M,g))
VVtildemat0 = matrix(0,(M^2+M)/2,g)
VV0=array(0,dim=c(M,M,g))
mm0=matrix(0,n,g)
WW0=array(0,dim=c(n,n,g))
tcholWW0=array(0,dim=c(n,n,g))


for (i in 1:g)
{
  mu0[,i]=i*rnorm_ALB(M)
  VVtildemat0[,i] = i*rnorm_ALB((M^2+M)/2)

  temp=matrix(0,M,M)
  temp[lower.tri(temp,diag=TRUE)]=VVtildemat0[,i]
  VVtilde0[,,i] =temp
  VV0[,,i] = tcrossprod(VVtilde0[,,i]) + kappa1*diag(M)

  mm0[,i] = BB0%*%mu0[,i]
  WW0[,,i] = BB0%*%VV0[,,i]%*%t(BB0)+PSI0
  tcholWW0[,,i] = t(chol(WW0[,,i]))
}









## generate mixture of normal data
XX = matrix(0,TT,n)

for (t in 1:TT)
{
  ind = sample(c(1:g),1,prob=pi0)
  XX[t,] = mm0[,ind] + tcholWW0[,,ind]%*%rnorm(n)
  }

## add NAs
temp = matrix(rbinom(TT*n,1,.85),TT,n)
XX[temp==0]=NA





nametemp=paste0("BB0_",modl,".tex")
x=xtable(BB0,align=rep("",ncol(BB0)+1)) 
print(x, floating=FALSE, tabular.environment="pmatrix", 
      hline.after=NULL, include.rownames=FALSE, include.colnames=FALSE,file=nametemp)

nametemp=paste0("xi0_",modl,".tex")
x=xtable(matrix(xi0,ncol=1),align=rep("",2)) 
print(x, floating=FALSE, tabular.environment="pmatrix", 
      hline.after=NULL, include.rownames=FALSE, include.colnames=FALSE,file=nametemp)

nametemp=paste0("mu0_",modl,".tex")
x=xtable(mu0,align=rep("",ncol(mu0)+1)) 
print(x, floating=FALSE, tabular.environment="pmatrix", 
      hline.after=NULL, include.rownames=FALSE, include.colnames=FALSE,file=nametemp)

nametemp=paste0("psitilde0_",modl,".tex")
x=xtable(matrix(psitilde0,ncol=1),align=rep("",2)) 
print(x, floating=FALSE, tabular.environment="pmatrix", 
      hline.after=NULL, include.rownames=FALSE, include.colnames=FALSE,file=nametemp)

nametemp=paste0("VVtildemat0_",modl,".tex")
x=xtable(VVtildemat0,align=rep("",ncol(VVtildemat0)+1)) 
print(x, floating=FALSE, tabular.environment="pmatrix", 
      hline.after=NULL, include.rownames=FALSE, include.colnames=FALSE,file=nametemp)
