gradient1 = function(parameters,XX,kappa1,kappa2,M,g,ind.select)
{
  TT = nrow(XX)
  n  = ncol(XX)
  nrparam = g-1 + g*M+g*M*(M+1)/2 + M*n+n
  
  paramlist=extractparam(parameters,XX,kappa1,kappa2,M,g)
  
  mm=paramlist$mm
  WW=paramlist$WW
  pi=paramlist$pi
  PSITILDE=paramlist$PSITILDE
  xi=paramlist$xi
  BB=paramlist$BB
  VVtilde=paramlist$VVtilde
  mu=paramlist$mu
  VV=paramlist$VV
  PSI=paramlist$PSI
  psitilde=paramlist$psitilde

########################################################################################
Sstar = matrix(0,g-1,g)
Sstar[,2:g] = diag(g-1)

gradxistar   = rep(0,g-1)
gradmu       = matrix(0,M,g)
gradVVtilde  = matrix(0,(M^2+M)/2,g)
gradvecB     = rep(0,n*M)
gradpsitilde = rep(0,n)

for (t in 1:TT)
{
  ind = which(is.na(XX[t,])==FALSE)
  temp=rep(0,g)
  for (i in 1:g)
  {
    temp[i] = log(pi[i]) + dmvnorm(as.vector(XX[t,ind]),mean=as.vector(mm[ind,i]),sigma=as.matrix(WW[ind,ind,i]),log=TRUE)
  }
  pibar = logfracfun(temp)
  
  for (i in 1:g)
  {
    pp=rep(0,n)
    PP=matrix(0,n,n)
    
    WWtempinv = chol2inv(chol(WW[ind,ind,i]))
    pp[ind] = WWtempinv%*%(XX[t,ind]-mm[ind,i])
    PP[ind,ind] = WWtempinv
    PP = PP - tcrossprod(pp)
    
    ee = rep(0,g); ee[i]=1

    alpha1 = 2/(xi[i]^2)*Sstar%*%(xi[i]*ee - pi[i]*xi) ## doesn't depend on t, no need to compute TT times
    alpha2 = t(BB)%*%pp
    alpha3 = -vech(t(BB)%*%PP%*%BB%*%VVtilde[,,i])
    alpha4 = c(pp%*%t(mu[,i]) - PP%*%BB%*%VV[,,i])
    alpha5 = -diag(PSITILDE%*%PP)
    
    gradxistar      = gradxistar + pibar[i]*alpha1
    gradmu[,i]      = gradmu[,i] + pibar[i]*alpha2
    gradVVtilde[,i] = gradVVtilde[,i] + pibar[i]*alpha3
    gradvecB        = gradvecB + pibar[i]*alpha4
    gradpsitilde    = gradpsitilde + pibar[i]*alpha5
  }
}

  grad = c(gradxistar,c(gradmu),c(gradVVtilde),gradvecB,gradpsitilde)
  
  grad = grad[ind.select]
  
 return(-grad)
 
}