hessian1 = function(parameters,XX,kappa1,kappa2,M,g,ind.select)
{
  TT = nrow(XX)
  n  = ncol(XX)
  nrparam = g-1 + g*M+g*M*(M+1)/2 + M*n+n
  
  paramlist=extractparam(parameters,XX,kappa1,kappa2,M,g)
  
  mm=paramlist$mm
  WW=paramlist$WW
  pi=paramlist$pi
  PSITILDE=paramlist$PSITILDE
  xi=paramlist$xi
  BB=paramlist$BB
  VVtilde=paramlist$VVtilde
  mu=paramlist$mu
  VV=paramlist$VV
  PSI=paramlist$PSI
  psitilde=paramlist$psitilde

  
  minHH    = matrix(0,nrparam,nrparam)
  mattemp1 = matrix(0,nrparam,nrparam)  
  mattemp2 = matrix(0,nrparam,nrparam)
    
  Sstar = matrix(0,g-1,g)
  Sstar[,2:g] = diag(g-1)
  
  ## these 4 matrices: can be defined beforehand
  KKnm  = commutation.matrix( n, M )# commutation matrix
  KKmm  = commutation.matrix( M, M )
  Deltn = matrix(0,n,n^2);   for (ii in 1:n) {temp=(ii-1)*n+ii; Deltn[ii,temp]=1}
  LLm   = elimination.matrix(M)   # elimination matrix

  ind0=c(1:(g-1))
  ind1=c(1:(g*M))
  ind2=c((g*M+1):(g*M+g*M*(M+1)/2))
  ind3=c((g*M+g*M*(M+1)/2+1):(g*M+g*M*(M+1)/2 + M*n))
  ind4=c((g*M+g*M*(M+1)/2 + M*n+1):(g*M+g*M*(M+1)/2 + M*n+n))
  
  
  
  
  for (t in 1:TT)
  {
    ind = which(is.na(XX[t,])==FALSE)
    temp=rep(0,g)
    for (i in 1:g)
    {
      temp[i] = log(pi[i]) + dmvnorm(as.vector(XX[t,ind]),mean=as.vector(mm[ind,i]),sigma=as.matrix(WW[ind,ind,i]),log=TRUE)
    }
    pibar = logfracfun(temp) ## this function takes log(a), log(b), log(c) and produces a/(a+b+c), b/(a+b+c), c/(a+b+c)
    
    # these are all (t) variables:
    AAbar11       = matrix(0,g-1,g-1)
    AAbar1star    = matrix(0,g-1,nrparam-g+1)
    AAbarstarstar = matrix(0,nrparam-g+1,nrparam-g+1)
    aabar1        = rep(0,g-1) 
    aabarstar     = rep(0,nrparam-g+1)

        
    for (i in 1:g)
    {
      ee = rep(0,g); ee[i]=1
      
      ## these are (i.t) variables
      AA=matrix(0,nrparam-g+1,nrparam-g+1)
      pp=rep(0,n)
      PP=matrix(0,n,n)
      QQ=matrix(0,n,n)
      
      WWtempinv = chol2inv(chol(WW[ind,ind,i]))
      pp[ind] = WWtempinv%*%(XX[t,ind]-mm[ind,i])
      QQ[ind,ind] = WWtempinv
      PP = QQ - tcrossprod(pp)

      alpha1 = 2/(xi[i]^2)*Sstar%*%(xi[i]*ee - pi[i]*xi) ## doesn't depend on t, no need to compute TT times
      alpha2 = t(BB)%*%pp
      alpha3 = -vech(t(BB)%*%PP%*%BB%*%VVtilde[,,i])
      alpha4 = c(pp%*%t(mu[,i]) - PP%*%BB%*%VV[,,i])
      alpha5 = -diag(PSITILDE%*%PP)
      aa     = c(kronecker(ee,alpha2),kronecker(ee,alpha3),alpha4,alpha5) # this is aa(it)


      AA11 = 2*Sstar%*%(xi[i]^2*diag(g)+2*xi[i]*(xi%*%t(ee) +ee%*%t(xi)) -4*pi[i]*tcrossprod(xi) - as.double(crossprod(xi))*tcrossprod(ee))%*%t(Sstar)/(xi[i]^2*as.double(crossprod(xi)))  # doesn't depend on t, does depend on i, p10    

      aabar1     = aabar1     + pibar[i]*alpha1
      aabarstar  = aabarstar  + pibar[i]*aa
      AAbar1star = AAbar1star + pibar[i]*alpha1%*%t(aa)
      AAbar11    = AAbar11    + pibar[i]*AA11      
      
      AA22 = t(BB)%*%QQ%*%BB
      AA23 = kronecker(t(pp)%*%BB%*%VVtilde[,,i],t(BB)%*%QQ%*%BB) + kronecker(t(BB)%*%QQ%*%BB%*%VVtilde[,,i],t(pp)%*%BB)
      AA24 = kronecker(t(mu[,i] + VV[,,i]%*%t(BB)%*%pp),t(BB)%*%QQ) - kronecker(diag(M)-t(BB)%*%QQ%*%BB%*%VV[,,i],t(pp))
      AA25 = 2*kronecker(t(pp),t(BB)%*%QQ%*%PSITILDE)
      AA33 = kronecker(diag(M)-t(VVtilde[,,i])%*%t(BB)%*%PP%*%BB%*%VVtilde[,,i],t(BB)%*%QQ%*%BB) -
              kronecker(diag(M)-t(VVtilde[,,i])%*%t(BB)%*%QQ%*%BB%*%VVtilde[,,i],t(BB)%*%tcrossprod(pp)%*%BB) +
              (kronecker(t(VVtilde[,,i])%*%t(BB)%*%tcrossprod(pp)%*%BB,t(BB)%*%QQ%*%BB%*%VVtilde[,,i]) + kronecker(t(VVtilde[,,i])%*%t(BB)%*%QQ%*%BB,t(BB)%*%tcrossprod(pp)%*%BB%*%VVtilde[,,i]))%*%KKmm - 
              kronecker(t(VVtilde[,,i])%*%t(BB)%*%QQ%*%BB,t(BB)%*%QQ%*%BB%*%VVtilde[,,i])%*%KKmm   
      AA34 = kronecker(t(VVtilde[,,i])-t(VVtilde[,,i])%*%t(BB)%*%QQ%*%BB%*%VV[,,i],t(BB)%*%PP)+
              kronecker(t(VVtilde[,,i])%*%t(BB)%*%pp%*%t(mu[,i]+VV[,,i]%*%t(BB)%*%pp),t(BB)%*%QQ)+
               (kronecker(t(VVtilde[,,i])%*%t(BB)%*%PP,diag(M)-t(BB)%*%QQ%*%BB%*%VV[,,i]) + kronecker(t(VVtilde[,,i])%*%t(BB)%*%QQ,t(BB)%*%pp%*%t(mu[,i]+VV[,,i]%*%t(BB)%*%pp)))%*%KKnm
      AA35 = 2*kronecker(t(VVtilde[,,i])%*%t(BB)%*%QQ%*%PSITILDE,t(BB)%*%tcrossprod(pp)) - 
               2*kronecker(t(VVtilde[,,i])%*%t(BB)%*%PP,t(BB)%*%QQ%*%PSITILDE)
      AA44 = kronecker(tcrossprod(mu[,i]+VV[,,i]%*%t(BB)%*%pp),QQ) +
              kronecker(VV[,,i]-VV[,,i]%*%t(BB)%*%QQ%*%BB%*%VV[,,i],PP) +
               (kronecker((mu[,i]+VV[,,i]%*%t(BB)%*%pp)%*%t(pp),QQ%*%BB%*%VV[,,i]) + kronecker(VV[,,i]%*%t(BB)%*%QQ,pp%*%t(mu[,i]+VV[,,i]%*%t(BB)%*%pp)))%*%KKnm -
                 kronecker(VV[,,i]%*%t(BB)%*%QQ,QQ%*%BB%*%VV[,,i])%*%KKnm
      AA45 = 2*kronecker((mu[,i]+VV[,,i]%*%t(BB)%*%pp)%*%t(pp),QQ%*%PSITILDE) - 
               2*kronecker(VV[,,i]%*%t(BB)%*%QQ,PP%*%PSITILDE)
      AA55 = kronecker(PP,diag(n)) + 2*kronecker(QQ,PSITILDE%*%tcrossprod(pp)%*%PSITILDE) - 2*kronecker(PP,PSITILDE%*%QQ%*%PSITILDE)

      # this is AA(it) p11. 16 elements to fill up

      AA[ind1,ind1] = kronecker(tcrossprod(ee),AA22)
      AA[ind2,ind2] = kronecker(tcrossprod(ee),LLm%*%AA33%*%t(LLm))  
      AA[ind3,ind3] = AA44
      AA[ind4,ind4] = Deltn%*%AA55%*%t(Deltn)
            
      AA[ind1,ind2] = kronecker(tcrossprod(ee),AA23%*%t(LLm))
      AA[ind2,ind1] = t(AA[ind1,ind2])
      
      AA[ind1,ind3] = kronecker(ee,AA24)
      AA[ind3,ind1] = t(AA[ind1,ind3])
        
      AA[ind1,ind4] = kronecker(ee,AA25%*%t(Deltn))
      AA[ind4,ind1] = t(AA[ind1,ind4])
        
      AA[ind2,ind3] = kronecker(ee,LLm%*%AA34)
      AA[ind3,ind2] = t(AA[ind2,ind3])
        
      AA[ind2,ind4] = kronecker(ee,LLm%*%AA35%*%t(Deltn))
      AA[ind4,ind2] = t(AA[ind2,ind4])

      AA[ind3,ind4] = AA45%*%t(Deltn)
      AA[ind4,ind3] = t(AA[ind3,ind4])

      AAbarstarstar = AAbarstarstar + pibar[i]*(AA-tcrossprod(aa))
       } ##for (i in 1:g)
    

  mattemp1[1:(g-1),1:(g-1)]     = AAbar11
  mattemp1[1:(g-1),g:nrparam]   = - AAbar1star
  mattemp1[g:nrparam,1:(g-1)]   = -t(AAbar1star)
  mattemp1[g:nrparam,g:nrparam] = AAbarstarstar

  mattemp2[1:(g-1),1:(g-1)]     = tcrossprod(aabar1)
  mattemp2[1:(g-1),g:nrparam]   = aabar1%*%t(aabarstar)
  mattemp2[g:nrparam,1:(g-1)]   = t(mattemp2[1:(g-1),g:nrparam]) 
  mattemp2[g:nrparam,g:nrparam] = tcrossprod(aabarstar)

  minHH = minHH + mattemp1 + mattemp2
  
  }  ## for (t in 1:TT)
  

minHH=minHH[ind.select,ind.select]  
  
return(minHH)  
  
  
  
}


